/**
 * Fancy Timer
 * Show countdown timer or realtime clock
 *
 * @author Oleksii Teterin <altmoc@gmail.com>
 * @version 1.0.2
 * @license ISC http://opensource.org/licenses/ISC
 * @date 2020-07-05
 * @host https://github.com/Lexxus/fancy-timer
 */
!function(t){if("object"==typeof module&&"object"==typeof module.exports){var e=t(require,exports);void 0!==e&&(module.exports=e)}else if("function"==typeof define&&define.amd)define(["require","exports"],t);else{var i={};t(null,i),window.FancyTimer=i.FancyTimer}}((function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FancyTimer=void 0;var i=function(){function t(t,e){var i=this;this.timestamp=0,this.value=0,this.direction=0;var n=e.captions,r=e.showDays,a=void 0===r?0:r;this.container=t,this.tick=this.tick.bind(this),this.handleTransitionEnd=this.handleTransitionEnd.bind(this),this.updateOptions(e);var o=s(null==n?void 0:n.seconds),h=s(null==n?void 0:n.minutes),d=s(null==n?void 0:n.hours),l=a>0&&a<=6?s(null==n?void 0:n.days,a):void 0;if(this.element={seconds:o,minutes:h,hours:d,days:l},t.innerHTML="",l){t.appendChild(l);var c=document.createElement("span");c.className="ft-space",t.appendChild(c)}t.appendChild(d);var u=document.createElement("span");u.className="ft-delimiter",t.appendChild(u),t.appendChild(h),t.appendChild(u.cloneNode()),t.appendChild(o),t.querySelectorAll(".ft-shifter").forEach((function(t){var e=t.offsetHeight;t.parentElement.style.height=e/2+"px",t.addEventListener("transitionend",i.handleTransitionEnd)})),this.update(this.value,!0),this.direction&&this.start(this.direction)}return t.prototype.destroy=function(){var t=this;this.container.querySelectorAll(".ft-shifter").forEach((function(e){e.removeEventListener("transitionend",t.handleTransitionEnd)}))},t.prototype.start=function(t){var e=t&&Math.abs(t)<2?t:this.direction;if(e){this.intervalId&&this.stop(),this.timestamp=Date.now();var i=window.setInterval;this.direction=e,this.intervalId=i(this.tick,1e3)}},t.prototype.stop=function(){window.clearInterval(this.intervalId),this.intervalId=0,this.value=this.getActualValue()},t.prototype.update=function(t,e){void 0===e&&(e=!1);var i=Math.floor(t/86400),n=t%86400,s=Math.floor(n/3600);n%=3600;var a=Math.floor(n/60),o=n%60,h=this.element;h.days&&r(h.days,i,e,this.reverse),r(h.hours,s,e,this.reverse),r(h.minutes,a,e,this.reverse),r(h.seconds,o,e,this.reverse)},t.prototype.updateOptions=function(t){var e=t.value,i=t.direction,n=t.warn,s=t.reverseAnimation,r=t.onFinish,a=t.onWarning;this.direction=i&&Math.abs(i)<2?i:this.direction,this.reverse=s,this.warn=n,this.onFinish=r,this.onWarning=a,this.setValue(e),this.reverse?this.container.classList.add("ft-reverse"):this.container.classList.remove("ft-reverse")},t.prototype.setValue=function(t){switch(this.timestamp=Date.now(),typeof t){case"number":this.value=t;break;case"object":t instanceof Date&&(this.value=n(t),this.value<0?(this.value=Math.abs(this.value),this.direction=1):this.direction=-1);break;case"string":if(/^[012]?\d:[0-5]?\d:[0-5]?\d$/.test(t)){var e=(new Date).toISOString().split("T")[0],i=new Date(e+"T"+t);this.value=n(i)}}},t.prototype.getActualValue=function(){var t=Math.round((Date.now()-this.timestamp)/1e3);return this.value+t*this.direction},t.prototype.tick=function(){if(this.direction){var t=this.getActualValue();if(t<0?(this.stop(),"function"==typeof this.onFinish&&this.onFinish()):this.update(t),this.warn){var e=this.direction<0&&t>=0&&this.warn.secondsLeft>=t,i=this.warn.className||"ft-warn",n=this.container.classList,s=n.contains(i);e&&!s?(n.add(i),"function"==typeof this.onWarning&&this.onWarning()):!e&&s&&n.remove(i)}}else this.stop()},t.prototype.handleTransitionEnd=function(t){var e=t.target,i=this.reverse?1:0,n=this.reverse?0:1;e.children[n].textContent=e.children[i].textContent,e.classList.remove("ft-transit")},t}();function n(t){var e=t.getTime()||0;return Math.round((e-Date.now())/1e3)}function s(t,e){void 0===e&&(e=2);var i=document.createElement("figure");return i.className="ft-digits",i.innerHTML=function(t){for(var e="",i=0;i<t;i++)e+='<div class="ft-digit"><ul class="ft-shifter"><li>0</li><li>0</li></ul></div>';return e}(e)+(t?'<figcaption class="ft-caption">'+t+"</figcaption>":""),i}function r(t,e,i,n){void 0===n&&(n=!1);var s=t.querySelectorAll(".ft-digit"),r=n?1:0,a=n?0:1,o=e.toString();o.length<s.length&&(o="0000".substr(0,s.length-o.length)+o),s.forEach((function(t,e){var n=t.firstElementChild,s=n.children,h=s[a].textContent,d=o[e];h!==d&&(i?s[a].textContent=d:(s[r].textContent=d,n.classList.add("ft-transit")))}))}e.FancyTimer=i,e.default=i}));